﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;

namespace MyClock
{
    class IniFile
    {
        /// <summary>
        /// <Ver 1.17.4>INIファイルから取得する
        /// </summary>
        /// <param name="lpSection">セッション名称</param>
        /// <param name="lpKeyName">キー名称</param>
        /// <param name="lpFileName">INIファイル名</param>
        /// <returns></returns>
        public static string GetIniString(string lpSection, string lpKeyName, string lpFileName)
        {
            System.Text.StringBuilder strValue = new System.Text.StringBuilder(1024);

            uint sLen = WinAPI.GetPrivateProfileString(lpSection, lpKeyName, "", strValue, 1024, lpFileName);

            return strValue.ToString();
        }

        /// <summary>
        /// INIファイルに書き込む
        /// </summary>
        /// <param name="lpSection">セッション名称</param>
        /// <param name="lpKeyName">キー名称</param>
        /// <param name="lpValue">セットする値</param>
        /// <param name="lpFileName">INIファイル名</param>
        /// <returns></returns>
        public static bool SetIniString(string lpSection, string lpKeyName, string lpValue, string lpFileName)
        {
            long result = WinAPI.WritePrivateProfileString(lpSection, lpKeyName, lpValue, lpFileName);
            return result != 0;
        }
    }
}
