﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
//using System.Threading.Tasks; // <Ver1.00>.NET Franework 3.5 では使えないのでコメントアウト
using System.Windows.Forms;

namespace MyClock
{
    static class Program
    {
        /// <summary>
        /// アプリケーションのメイン エントリ ポイントです。
        /// </summary>
        [STAThread]
        static void Main()
        {
#if DEBUG
            // <Ver 1.17.3>デバッグ時は二重起動を許すように変更 (#if Debug / #endif で既定)
            // 自動生成されたコード
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Display());
#endif
#if DEBUG
            goto end;
#endif
            // <Ver 1.00>二重起動の禁止 - mutexを利用したプロセスの排他処理
            // <Ver 1.17.3>デバッグ時は二重起動を許すように変更 (#if Debug / #endif で既定)
            // Mutex名を決める (MyClock固有の文字列)
            string mutexName = "MyClockbyKrtyski"; // <Ver 1.11>"Krtyski作成のMyClock"に限定
            //MyClockのMutexオブジェクトを作成する
            System.Threading.Mutex mutex = new System.Threading.Mutex(false, mutexName);
            bool gotHandle = false;

            try
            {
                try
                {
                    //ミューテックスの取得を試みる
                    gotHandle = mutex.WaitOne(0, false);
                }
                //例外処理 (.NET Framework 2.0以降で有効らしい)
                catch (System.Threading.AbandonedMutexException)
                {
                    //別のMyClockがミューテックスを解放しないで終了(異常終了)した時
                    gotHandle = true;
                }

                //ミューテックスを得られたかどうか？
                if (gotHandle == false)
                {
                    //得られなかった場合は、すでに MyClock が起動していると判断して終了する
                    //メッセージボックスは動作確認のため。実際は黙って終了
                    //MessageBox.Show("MyClockは既に起動しています.");
                    return;
                }
                // 自動生成されたコードを実行
                Application.EnableVisualStyles();
                Application.SetCompatibleTextRenderingDefault(false);
                Application.Run(new Display());
            }
            finally
            {
                if (gotHandle)
                {
                    //ミューテックスを解放する
                    mutex.ReleaseMutex();
                }
                mutex.Close();
            }
#if DEBUG
        end:;
#endif
        }
    }
}
